SystemOrganization addCategory: #'PEGWiki-Examples'!

!ALExamplePage methodsFor: '*pegwiki-examples' stamp: 'chc 1/20/2016 00:47'!
initialize
	examples := {
		'ajax counter' -> ALAjaxCounterExample.
		'unicode' -> ALEncodingExample.
		'streaming' -> ALStreamingExample.
		'counter' -> ALCounterExample.
		'pjax counter' -> ALPjaxCounterExample.
		'form' -> ALFormExample.
	}.
	current := examples first value new.! !

!ALExamplePage methodsFor: '*pegwiki-examples' stamp: 'chc 3/30/2016 09:49'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'ooplu'.
			self renderStylesOn: html].
		html body: [ self renderBodyOn: html ] ]! !

!ALExamplePage methodsFor: '*pegwiki-examples' stamp: 'chc 3/30/2016 09:45'!
renderNavBarOn: html
	html img src: 'logo_ooplu.png'. 
	"html ul:
		[examples do:
			[:pair |
			html li:
				[html a
					navigate: [current := pair value new];
					with: pair key]]]."
	"html br. 
	((PWDictionaryModel storage at: #render) = 'on') ifTrue: [
		html a navigate: [current := ALAjaxCounterExample new]; with: 'Version Loader']"! !

ALFormExample subclass: #PWFormExamples
	instanceVariableNames: 'radio integer2 integer3 dropdown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Examples'!

!PWFormExamples commentStamp: 'chc 3/22/2016 09:30' prior: 0!
This is a class for adding to the ALFormExamples page!

!PWFormExamples methodsFor: 'as yet unclassified' stamp: 'hc 3/10/2016 10:30'!
initialize
	integer := 'start string 2'.
	radio := ''.
	integer2 := 0.
	integer3 := 0.
	dropdown := 'peaches'! !

!PWFormExamples methodsFor: 'as yet unclassified' stamp: 'chc 2/2/2016 11:28'!
renderContentOn: html
	super renderContentOn: html! !

!PWFormExamples methodsFor: 'as yet unclassified' stamp: 'hc 2/25/2016 12:26'!
renderFormsOn: html
	html p: 'Two Integer Inputs:'.
	html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer2 printString;
			callback: [:str | integer2 := str asNumber];
			with: [].
		html input 
			beTypeText
			value: integer3 printString;
			callback: [:str | integer3 := str asNumber];
			with: [].
		html input beTypeSubmit.
		html br.
		html text: integer2 asWords.
		html br.
		html text: integer3 asWords].
	html p: 'Radio Button:'.
	html form beMethodGet; with:
		[html input beTypeRadio
			value: 'male';
			callback: [:str | radio := str ].
		html br. 
		html input beTypeRadio
			value: 'female';
			callback: [:str | radio := str ].
		html br.
		html input beTypeSubmit.
		html text: radio ].
	html p: 'Ordered List:'.
	html ol:
		[#('apples' 'oranges' 'grapes') do:
			[:i | 
			html li:
				[html text: i ]]].
	html p: 'Unordered List:'.
	html ul:
		[#('apples' 'oranges' 'grapes') do:
			[:each | 
			html li: each ]].
	html p: 'Drop-down List:'.
	html form beMethodGet; with:
		[html select 
				callback: [:str| dropdown := str ];
					with: [html option with: [html text: 'superduper'].
						   html option with: [html text: 'another'].
						    html option with: [html text: 'garycooper']].
		html input beTypeSubmit.
		html br.
		html p: dropdown].

! !

!ALAjaxCounterExample methodsFor: '*pegwiki-examples' stamp: 'chc 1/2/2016 09:20'!
libraryScript
	^ '
function Counter(url) {
  this.update(url);
};

Counter.prototype.install = function Counter_install(count, dec, inc) {
  var self = this;
  this.count = $(count);
  $(dec).click(function() {self.update(self.state.dec)});
  $(inc).click(function() {self.update(self.state.inc);});
};

Counter.prototype.update = function Counter_update(url) {
  var self = this;
  $.getJSON(url, function(json) {
    self.state = json;
    self.count.html(self.state.count);
  });
};
'! !

!ALAjaxCounterExample methodsFor: '*pegwiki-examples' stamp: 'chc 1/4/2016 10:49'!
renderFormScriptOn: html
	html raw: 
		'function ConvertFormToJson(form) {
			var array = (form).serializeArray();
			var json = {};
			jQuery.each( array, function () {
			json[this.name] = this.value || '' '';
		});
		return json;
		}

		$(myform).submit(function(event){
		event.preventDefault();

		var json = ConvertFormToJson($(myform));
		console.log(json);

		jsonstring = JSON.stringify(json);
		console.log(jsonstring);

		$.ajax({
		type: "POST",
		url: "'.

	html text: (html context registerResource: self resource) printString.

	html raw: 
		'",
		data: jsonstring,
		success: function (data) {
					var self = this;
					self.state = data;
					$(''#count'').html(self.state.count);
									}
		}) 
							});'! !

!ALAjaxCounterExample methodsFor: '*pegwiki-examples' stamp: 'chc 1/1/2016 07:08'!
renderInitScriptOn: html
	html raw: 'var counter = new Counter("'.
	html text: (html context registerResource: self resource) printString.
	html raw: '"); counter.install("#count", "#dec", "#inc");' ! !

!ALAjaxCounterExample methodsFor: '*pegwiki-examples' stamp: 'chc 3/23/2016 09:19'!
resource
	| wikiString wikiGrammar parser html |
	wikiString := PWSeasidePrefsModel instance valueAt: #currentString.
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	^ ALJsonResource component: (PWAjaxComponent html: html)! !
